; Simulator console driver. This provides a console device (0,0).
; Adam Sampson, azz@josstix.demon.co.uk
; This is a good example of a basic console driver for new devices.
; The simulator supports only 0dh for carriage return, and only 
; 08h for backspace. 0ah should be dropped by console drivers (but NOT by
; serial drivers, as they're used for binaries).

chgto0a:	LD A,0ah
		; FALL THROUGH!

; Behaviour: do any setup needed. This is the first routine called.
simconinit:	RET

; Behaviour: print the char in C to the screen.
simconout:	LD A,C
		CP 0dh
		CALL Z,chgto0a
		OUT (0h),A
		RET

; Behaviour: get a character into A. Block until a character is available.
simconin:	IN A,(0h)
contsimconin:	CP 0ah
		RET NZ
		LD A,0dh
		RET

; Behaviour: return in A 0 if a character waiting, 1 if not.
simconst:	LD A,0h 	; "always keys available"
				; Nothing uses this routine anyway!
	        RET

; Provide device 0. You can call your routines "ttyinit" etc., but this
; makes it easier to change a console driver into a serial driver etc.
ttyinit:	EQU simconinit
ttyout:		EQU simconout
ttyin:		EQU simconin
ttyst:		EQU simconst
